Index: sources/app/src/main/java/parkup/entities/RegistriranParkirac.java
===================================================================
--- sources/app/src/main/java/parkup/entities/RegistriranParkirac.java	(revision 2ace8f05cb6199d05ce30472306247199bdbfa30)
+++ sources/app/src/main/java/parkup/entities/RegistriranParkirac.java	(revision 9ff45d65e1d0058eb0c79395ba62a726630c2daa)
@@ -51,4 +51,7 @@
     private String role;
 
+    @OneToOne
+    private ParkingSession session;
+
     private boolean locked;
 
@@ -58,4 +61,5 @@
         this.regTablicki = new ArrayList<Tablicka>();
         this.role = "ROLE_REGISTRIRAN_PARKIRAC";
+        session=null;
     }
 
@@ -69,4 +73,5 @@
         this.mobile = mobile;
         this.role = "ROLE_REGISTRIRAN_PARKIRAC";
+        session=null;
     }
 
@@ -79,4 +84,5 @@
         this.mobile = mobile;
         this.role = "ROLE_REGISTRIRAN_PARKIRAC";
+        session=null;
     }
 
@@ -88,5 +94,27 @@
         this.mobile = mobile;
         this.role = "ROLE_REGISTRIRAN_PARKIRAC";
-    }
+        session=null;
+    }
+
+    public ParkingSession getSession() {
+        return session;
+    }
+
+    public void setSession(ParkingSession session) {
+        this.session = session;
+    }
+
+    public boolean isLocked() {
+        return locked;
+    }
+
+    public void setLocked(boolean locked) {
+        this.locked = locked;
+    }
+
+    public void setEnabled(boolean enabled) {
+        this.enabled = enabled;
+    }
+
 
     public int getRegParkId() {
Index: sources/app/src/main/java/parkup/entities/Vraboten.java
===================================================================
--- sources/app/src/main/java/parkup/entities/Vraboten.java	(revision 2ace8f05cb6199d05ce30472306247199bdbfa30)
+++ sources/app/src/main/java/parkup/entities/Vraboten.java	(revision 9ff45d65e1d0058eb0c79395ba62a726630c2daa)
@@ -4,4 +4,5 @@
 import org.springframework.security.core.userdetails.UserDetails;
 import parkup.data.VrabotenDemo;
+import parkup.data.enumarations.EmployeeStatus;
 
 import javax.persistence.*;
@@ -57,9 +58,12 @@
 
     @ManyToMany(cascade = {CascadeType.ALL})
-    @JoinColumn(name = "zona", nullable = false)
     private List<ParkingZone> parkingZones;
 
     @Column(name = "status")
-    private String status;
+    private EmployeeStatus status;
+
+    public void setLocked(boolean locked) {
+        this.locked = locked;
+    }
 
     @Column(name="locked")
@@ -73,6 +77,6 @@
         this.role = "ROLE_VRABOTEN";
         this.parkingZones = new ArrayList<ParkingZone>();
-        this.enabled = false;
-        this.status = "neRaboti";
+        this.enabled = true;
+        this.status = EmployeeStatus.NOT_WORKING;
     }
 
@@ -86,6 +90,6 @@
         this.parkingZones = parkingZones;
         this.role = "ROLE_VRABOTEN";
-        this.enabled = false;
-        this.status = "neRaboti";
+        this.enabled = true;
+        this.status = EmployeeStatus.NOT_WORKING;
     }
 
@@ -98,6 +102,6 @@
         this.parkingZones = parkingZones;
         this.role = "ROLE_VRABOTEN";
-        this.enabled = false;
-        this.status = "neRaboti";
+        this.enabled = true;
+        this.status = EmployeeStatus.NOT_WORKING;
     }
 
@@ -109,7 +113,7 @@
         this.mobile=mobile;
         this.parkingZones=new ArrayList<>();
-        this.enabled=false;
-        this.status="neRaboti";
         this.role="ROLE_VRABOTEN";
+        this.enabled=true;
+        this.status = EmployeeStatus.NOT_WORKING;
     }
 
@@ -204,7 +208,7 @@
     public void setParkingZones(List<ParkingZone> parkingZones) {this.parkingZones = parkingZones;}
 
-    public String getStatus() {return status;}
-
-    public void setStatus(String status) {this.status = status;}
+    public EmployeeStatus getStatus() {return status;}
+
+    public void setStatus(EmployeeStatus status) {this.status = status;}
 
     public boolean isAccount() {return enabled;}
Index: sources/app/src/main/java/parkup/repositories/ParkingSessionRepository.java
===================================================================
--- sources/app/src/main/java/parkup/repositories/ParkingSessionRepository.java	(revision 2ace8f05cb6199d05ce30472306247199bdbfa30)
+++ sources/app/src/main/java/parkup/repositories/ParkingSessionRepository.java	(revision 9ff45d65e1d0058eb0c79395ba62a726630c2daa)
@@ -4,8 +4,10 @@
 import parkup.entities.ParkingSession;
 
+import java.util.List;
+
 public interface ParkingSessionRepository extends JpaRepository<ParkingSession, Integer> {
 
     ParkingSession findByPssId(int parkingSessionId);
-
+    List<ParkingSession> findByParkingZonePzName(String pzName);
     void deleteByPssId(int parkingSessionId);
 }
Index: sources/app/src/main/java/parkup/repositories/ParkingSpaceRepository.java
===================================================================
--- sources/app/src/main/java/parkup/repositories/ParkingSpaceRepository.java	(revision 2ace8f05cb6199d05ce30472306247199bdbfa30)
+++ sources/app/src/main/java/parkup/repositories/ParkingSpaceRepository.java	(revision 9ff45d65e1d0058eb0c79395ba62a726630c2daa)
@@ -4,9 +4,9 @@
 import parkup.entities.ParkingSpace;
 
+import java.util.List;
+
 public interface ParkingSpaceRepository extends JpaRepository<ParkingSpace, Integer> {
     ParkingSpace findByPsName(String psName);
-
     ParkingSpace findByPsId(int parkingSpaceId);
-
     void deleteByPsId(int parkingSpaceId);
 }
Index: sources/app/src/main/java/parkup/repositories/ParkingZoneRepository.java
===================================================================
--- sources/app/src/main/java/parkup/repositories/ParkingZoneRepository.java	(revision 2ace8f05cb6199d05ce30472306247199bdbfa30)
+++ sources/app/src/main/java/parkup/repositories/ParkingZoneRepository.java	(revision 9ff45d65e1d0058eb0c79395ba62a726630c2daa)
@@ -3,5 +3,8 @@
 import org.springframework.data.jpa.repository.JpaRepository;
 import org.springframework.stereotype.Repository;
+import parkup.entities.ParkingSpace;
 import parkup.entities.ParkingZone;
+
+import java.util.List;
 
 @Repository
@@ -10,5 +13,4 @@
 
     ParkingZone findByPzName(String name);
-
     void deleteByPzId(int id);
 }
Index: sources/app/src/main/java/parkup/repositories/TablickaRepository.java
===================================================================
--- sources/app/src/main/java/parkup/repositories/TablickaRepository.java	(revision 9ff45d65e1d0058eb0c79395ba62a726630c2daa)
+++ sources/app/src/main/java/parkup/repositories/TablickaRepository.java	(revision 9ff45d65e1d0058eb0c79395ba62a726630c2daa)
@@ -0,0 +1,8 @@
+package parkup.repositories;
+
+import org.springframework.data.jpa.repository.JpaRepository;
+import parkup.data.Tablicka;
+
+public interface TablickaRepository extends JpaRepository<Tablicka,Integer> {
+    Tablicka findByTablica(String tablica);
+}
Index: sources/app/src/main/java/parkup/services/AdministratorService.java
===================================================================
--- sources/app/src/main/java/parkup/services/AdministratorService.java	(revision 2ace8f05cb6199d05ce30472306247199bdbfa30)
+++ sources/app/src/main/java/parkup/services/AdministratorService.java	(revision 9ff45d65e1d0058eb0c79395ba62a726630c2daa)
@@ -137,21 +137,5 @@
 
         String token = UUID.randomUUID().toString();
-<<<<<<< HEAD
-//        ConfirmationTokenRP confirmationToken = new ConfirmationTokenRP(
-//                token,
-//                LocalDateTime.now(),
-//                LocalDateTime.now().plusMinutes(15),
-//                administrator
-//        );
-=======
-        //ConfirmationTokenRP confirmationToken = new ConfirmationTokenRP(
-        //        token,
-        //        LocalDateTime.now(),
-        //        LocalDateTime.now().plusMinutes(15),
-        //        administrator
-        //);
->>>>>>> 9504a097ce80831ea7e7130dff7215d5fbf8e939
 
-        //confirmationTokenService.saveConfirmationToken(confirmationToken);
 
         // TODO: SEND EMAIL
Index: sources/app/src/main/java/parkup/services/ParkingSessionService.java
===================================================================
--- sources/app/src/main/java/parkup/services/ParkingSessionService.java	(revision 2ace8f05cb6199d05ce30472306247199bdbfa30)
+++ sources/app/src/main/java/parkup/services/ParkingSessionService.java	(revision 9ff45d65e1d0058eb0c79395ba62a726630c2daa)
@@ -4,23 +4,42 @@
 import org.springframework.stereotype.Service;
 import parkup.data.Tablicka;
+import parkup.data.enumarations.SessionStatus;
 import parkup.entities.ParkingSession;
+import parkup.entities.ParkingSpace;
+import parkup.entities.ParkingZone;
 import parkup.repositories.ParkingSessionRepository;
+import parkup.repositories.ParkingSpaceRepository;
+import parkup.repositories.ParkingZoneRepository;
+import parkup.repositories.TablickaRepository;
 
 import javax.transaction.Transactional;
+import java.time.Duration;
+import java.time.LocalDateTime;
 import java.util.List;
-import java.util.Objects;
 import java.util.Optional;
+import java.util.stream.Collectors;
 
 @Service
 public class ParkingSessionService {
     private final ParkingSessionRepository parkingSessionRepository;
+    private final ParkingZoneRepository parkingZoneRepository;
+    private final ParkingSpaceRepository parkingSpaceRepository;
+    private final TablickaRepository tablickaRepository;
 
     @Autowired
-    public ParkingSessionService(ParkingSessionRepository parkingSessionRepository) {
+    public ParkingSessionService(ParkingSessionRepository parkingSessionRepository, ParkingZoneRepository parkingZoneRepository, ParkingSpaceRepository parkingSpaceRepository, TablickaRepository tablickaRepository) {
         this.parkingSessionRepository = parkingSessionRepository;
+        this.parkingZoneRepository = parkingZoneRepository;
+        this.parkingSpaceRepository = parkingSpaceRepository;
+        this.tablickaRepository = tablickaRepository;
     }
 
+    //TODO add getMethod for paid sessions or all sessions
+
     public List<ParkingSession> getAllParkingSessions() {
-        return parkingSessionRepository.findAll();
+        //Get all sessions that arent paid
+        return parkingSessionRepository.findAll().stream()
+                .filter(s->!s.getStatus().equals(SessionStatus.ENDED_PAID))
+                .collect(Collectors.toList());
     }
 
@@ -30,5 +49,5 @@
     }
 
-    @Transactional
+   /* @Transactional
     public void updateParkingSession(int parkingSessionId, String timeStart, String timeEnd, Tablicka tablicka) {
         Optional<ParkingSession> parkingSessionOpt = Optional.ofNullable(parkingSessionRepository.findByPssId(parkingSessionId));
@@ -48,9 +67,10 @@
             throw new IllegalStateException("The ParkingSession does not exist");
         }
-    }
-
+    }*/
+    @Transactional
     public Optional<ParkingSession> deleteParkingSession(int parkingSessionId) {
         Optional<ParkingSession> parkingSessionOpt = Optional.ofNullable(parkingSessionRepository.findByPssId(parkingSessionId));
         if (parkingSessionOpt.isPresent()) {
+            parkingSessionOpt.get().getParkingSpace().setTaken(false);
             parkingSessionRepository.deleteByPssId(parkingSessionId);
             return parkingSessionOpt;
@@ -60,13 +80,103 @@
     }
 
-    public Optional<ParkingSession> addParkingSession(ParkingSession parkingSession) {
-        Optional<ParkingSession> parkingSessionOpt = Optional.ofNullable(parkingSessionRepository.findByPssId(parkingSession.getPssId()));
-        if (parkingSessionOpt.isPresent()) {
-            throw new IllegalStateException("ID already taken, ParkingSession cannot be added");
-        } else {
-            System.out.println(parkingSession);
-            parkingSessionRepository.save(parkingSession);
-            return parkingSessionOpt;
+    @Transactional
+    public Optional<ParkingSession> startParkingSession(String tablica, int parkingZoneId) {
+        ParkingZone parkingZone = parkingZoneRepository.findByPzId(parkingZoneId);
+        Tablicka tablicka = tablickaRepository.findByTablica(tablica);
+        if(tablicka==null) {
+            tablickaRepository.save(new Tablicka(tablica));
         }
+        tablicka=tablickaRepository.findByTablica(tablica);
+        ParkingSession sessionToAdd = new ParkingSession(tablicka);
+        sessionToAdd.setParkingZone(parkingZone);
+        parkingSessionRepository.save(sessionToAdd);
+        return Optional.of(sessionToAdd);
+
+    }
+
+//    public void executePayment(int id){
+//        ParkingSession session = parkingSessionRepository.findByPssId(id);
+//        if(session==null){
+//            throw new IllegalStateException("No such session exists");
+//        }
+//        else if(session.getStatus()== SessionStatus.ENDED_UNPAID){
+//            throw new IllegalStateException("Cannot execute payment on an ended session");
+//        }
+//        session.setStatus(SessionStatus.ENDED_PAID);
+//    }
+
+    public int calculatePayment(int id){
+        ParkingSession session = parkingSessionRepository.findByPssId(id);
+        if(session==null){
+            throw new IllegalStateException("No such session exists");
+        }
+        else if(session.getStatus()== SessionStatus.ENDED_UNPAID){
+            throw new IllegalStateException("Cannot calculate payment on an ended session");
+        }
+        int price = session.getParkingZone().getPrice();
+        return (int) (Math.ceil(Duration.between(session.getTimeEnd(),session.getTimeStart()).toMinutes()/60.0)*price);
+    }
+    @Transactional
+    public ParkingSession verifyParkingSession(int id,String parkingSpaceName,int parkingZoneId){
+        ParkingSession parkingSession = parkingSessionRepository.findByPssId(id);
+        ParkingZone parkingZone = parkingZoneRepository.findByPzId(parkingZoneId);
+        if(parkingSession==null){
+            throw new IllegalStateException("No such session exists");
+        }
+        else if(parkingSession.getStatus()==SessionStatus.STARTED_VERIFIED){
+            throw new IllegalStateException("The session you are trying to verify has already been verified");
+        }
+//        else if(parkingSession.getStatus()!=SessionStatus.STARTED_)
+        if(!parkingZone.getParkingSpaces().contains(parkingSpaceRepository.findByPsName(parkingSpaceName))){
+            throw new IllegalStateException("Ivalid parking space inserted. Type in a new parking space or let the admin know that they should add the parking space to this zone");
+        }
+        parkingSession.setStatus(SessionStatus.STARTED_VERIFIED);
+        ParkingSpace parkingSpace = parkingZoneRepository.findByPzId(parkingZoneId).getParkingSpaces().stream().filter(ps->ps.getPsName().equals(parkingSpaceName)).findFirst().get();
+        parkingSpace.setTaken(true);
+        parkingSession.setParkingSpace(parkingSpace);
+        return parkingSession;
+    }
+    @Transactional
+    public ParkingSession endParkingSession(int id){
+        ParkingSession parkingSession = parkingSessionRepository.findByPssId(id);
+        if(parkingSession==null){
+            throw new IllegalStateException("No such session exists");
+        }
+        else if(parkingSession.getStatus()==SessionStatus.ENDED_UNPAID){
+            throw new IllegalStateException("The session you are trying to end has already been ended");
+        }
+        parkingSession.setStatus(SessionStatus.ENDED_UNPAID);
+        parkingSession.setTimeEnd(LocalDateTime.now());
+        return parkingSession;
+    }
+    @Transactional
+    public boolean payParkingSession(int id,String date){
+        ParkingSession parkingSession = parkingSessionRepository.findByPssId(id);
+        String expMonthString=date.split("/")[0];
+        String expYearString=date.split("/")[1];
+        if(expMonthString.startsWith("0"))
+            expMonthString=expYearString.substring(1);
+        if(expYearString.startsWith("0"))
+            expYearString=expYearString.substring(1);
+        int expMonth=Integer.parseInt(expMonthString);
+        int expYear=Integer.parseInt(expYearString);
+        int month = LocalDateTime.now().getMonth().getValue();
+        int year = LocalDateTime.now().getYear()%100;
+        if(year>expYear){
+            throw new IllegalStateException("Your card has expired or the date that you have entered is incorrect");
+        }
+        else if(year==expYear){
+            if(month>=expMonth)
+                throw new IllegalStateException("Your card has expired or the date that you have entered is incorrect");
+        }
+        if(parkingSession==null){
+            throw new IllegalStateException("No such session exists");
+        }
+        else if(parkingSession.getStatus()==SessionStatus.ENDED_PAID){
+            throw new IllegalStateException("The session has already been paid for");
+        }
+        parkingSession.setStatus(SessionStatus.ENDED_PAID);
+        parkingSession.getParkingSpace().setTaken(false);
+        return true;
     }
 }
Index: sources/app/src/main/java/parkup/services/ParkingSpaceService.java
===================================================================
--- sources/app/src/main/java/parkup/services/ParkingSpaceService.java	(revision 2ace8f05cb6199d05ce30472306247199bdbfa30)
+++ sources/app/src/main/java/parkup/services/ParkingSpaceService.java	(revision 9ff45d65e1d0058eb0c79395ba62a726630c2daa)
@@ -5,4 +5,5 @@
 import parkup.entities.ParkingSpace;
 import parkup.repositories.ParkingSpaceRepository;
+import parkup.repositories.ParkingZoneRepository;
 
 import javax.transaction.Transactional;
@@ -10,12 +11,15 @@
 import java.util.Objects;
 import java.util.Optional;
+import java.util.stream.Collectors;
 
 @Service
 public class ParkingSpaceService {
     private final ParkingSpaceRepository parkingSpaceRepository;
+    private final ParkingZoneRepository parkingZoneRepository;
 
     @Autowired
-    public ParkingSpaceService(ParkingSpaceRepository parkingSpaceRepository) {
+    public ParkingSpaceService(ParkingSpaceRepository parkingSpaceRepository, ParkingZoneRepository parkingZoneRepository) {
         this.parkingSpaceRepository = parkingSpaceRepository;
+        this.parkingZoneRepository = parkingZoneRepository;
     }
 
@@ -29,17 +33,17 @@
     }
 
-    public Optional<ParkingSpace> addParkingSpace(ParkingSpace parkingSpace) {
-        Optional<ParkingSpace> parkingSpaceOpt = Optional.ofNullable(parkingSpaceRepository.findByPsName(parkingSpace.getPsName()));
-        if (parkingSpaceOpt.isPresent()) {
-            throw new IllegalStateException("Name already taken, try adding a ParkingZone with a different name");
+    public Optional<ParkingSpace> addParkingSpace(ParkingSpace parkingSpace,int parkingZoneId) {
+        List<String> names = parkingZoneRepository.findByPzId(parkingZoneId).getParkingSpaces().stream().map(ParkingSpace::getPsName).collect(Collectors.toList());
+        if (names.contains(parkingSpace.getPsName())) {
+            throw new IllegalStateException("Name already taken, try adding a ParkingSpace with a different name");
         } else {
             System.out.println(parkingSpace);
             parkingSpaceRepository.save(parkingSpace);
         }
-        return parkingSpaceOpt;
+        return Optional.of(parkingSpace);
     }
 
     @Transactional
-    public ParkingSpace updateParkingSpace(int parkingSpaceId, String psName, boolean taken, boolean handicaped, float lat, float lng) {
+    public ParkingSpace updateParkingSpace(int parkingSpaceId, String psName, boolean taken, float lat, float lng) {
         Optional<ParkingSpace> ParkingSpaceOpt = Optional.ofNullable(parkingSpaceRepository.findByPsId(parkingSpaceId));
         if (ParkingSpaceOpt.isPresent()) {
@@ -58,7 +62,4 @@
             }
 
-            if (!Objects.equals(ParkingSpaceNov.isHandicaped(), handicaped)) {
-                ParkingSpaceNov.setHandicaped(handicaped);
-            }
 
             if(lat!=0 && !Objects.equals(ParkingSpaceNov.getLat(), lat)){
@@ -85,3 +86,6 @@
         return parkingSpaceOpt;
     }
+    public long getNumberOfTakenSpaces(){
+        return parkingSpaceRepository.findAll().stream().filter(ParkingSpace::isTaken).count();
+    }
 }
Index: sources/app/src/main/java/parkup/services/ParkingZoneService.java
===================================================================
--- sources/app/src/main/java/parkup/services/ParkingZoneService.java	(revision 2ace8f05cb6199d05ce30472306247199bdbfa30)
+++ sources/app/src/main/java/parkup/services/ParkingZoneService.java	(revision 9ff45d65e1d0058eb0c79395ba62a726630c2daa)
@@ -2,11 +2,14 @@
 
 import org.springframework.beans.factory.annotation.Autowired;
-import org.springframework.data.jpa.repository.Modifying;
 import org.springframework.stereotype.Service;
 import parkup.data.ParkingZoneLocation;
+import parkup.entities.ParkingSession;
 import parkup.entities.ParkingSpace;
 import parkup.entities.ParkingZone;
 import parkup.entities.Vraboten;
+import parkup.repositories.ParkingSessionRepository;
+import parkup.repositories.ParkingSpaceRepository;
 import parkup.repositories.ParkingZoneRepository;
+import parkup.repositories.VrabotenRepository;
 
 import javax.transaction.Transactional;
@@ -19,8 +22,14 @@
 public class ParkingZoneService {
     private final ParkingZoneRepository parkingZoneRepository;
+    private final ParkingSpaceRepository parkingSpaceRepository;
+    private final VrabotenRepository vrabotenRepository;
+    private final ParkingSessionRepository parkingSessionRepository;
 
     @Autowired
-    public ParkingZoneService(ParkingZoneRepository parkingZoneRepository) {
+    public ParkingZoneService(ParkingZoneRepository parkingZoneRepository, ParkingSpaceRepository parkingSpaceRepository, VrabotenRepository vrabotenRepository, ParkingSessionRepository parkingSessionRepository) {
         this.parkingZoneRepository = parkingZoneRepository;
+        this.parkingSpaceRepository = parkingSpaceRepository;
+        this.parkingSessionRepository = parkingSessionRepository;
+        this.vrabotenRepository = vrabotenRepository;
     }
 
@@ -37,5 +46,5 @@
         List<ParkingZone> parkingZones = this.parkingZoneRepository.findAll();
         List<String> parkingZonesNames = new ArrayList<>();
-        for (ParkingZone pz : parkingZones){
+        for (ParkingZone pz : parkingZones) {
             parkingZonesNames.add(pz.getPzName());
         }
@@ -65,91 +74,88 @@
     }
 
-<<<<<<< HEAD
     //TODO proveri dali ima odgovorni i dokolku ima dali postojat vo bazata
     @Transactional
-    public ParkingZone updateParkingZone(int parkingZoneId, String pzName, int price, int capacity,
+    public ParkingZone updateParkingZone(int parkingZoneId, String pzName, int price,
                                          String location, int from, int to, String color,
-                                         List<ParkingSpace> parkingSpaces, ParkingZoneLocation parkingZoneLocation, List<Vraboten> odgovorniLica) {
+                                         List<ParkingSpace> parkingSpaces, ParkingZoneLocation parkingZoneLocation, List<Integer> odgovorniLica) {
 
-        for(ParkingSpace space:parkingSpaces){
-            System.out.println(space);
-        }
-        for(Vraboten v : odgovorniLica){
-            System.out.println(v.toString());
-        }
-=======
-    //TODO prati niza od objekti ParkingSpaces i prati objekt ParkingZoneLocation
-    @Transactional
-    public ParkingZone updateParkingZone(int parkingZoneId, String pzName, int price, int capacity,
-                                         String location, int from, int to, String color,
-                                         List<ParkingSpace> parkingSpaces, ParkingZoneLocation parkingZoneLocation) {
->>>>>>> 9504a097ce80831ea7e7130dff7215d5fbf8e939
-        Optional<ParkingZone> parkingZoneOpt = Optional.ofNullable(parkingZoneRepository.findByPzId(parkingZoneId));
-        if (parkingZoneOpt.isPresent()) {
+        //TODO prati niza od objekti ParkingSpaces i prati objekt ParkingZoneLocation
+
             ParkingZone parkingZoneNov = parkingZoneRepository.findByPzId(parkingZoneId);
-            if (pzName != null && pzName.length() > 1 && !Objects.equals(parkingZoneNov.getPzName(), pzName)) {
-                Optional<ParkingZone> parkingZoneOpt1 = Optional.ofNullable(parkingZoneRepository.findByPzName(pzName));
-                if (parkingZoneOpt1.isPresent()) {
-                    throw new IllegalStateException("There is already a ParkingZone with the same name");
+            if (parkingZoneNov!=null) {
+                if (pzName != null && pzName.length() > 1) { ;
+                    if (parkingZoneNov.getPzName().equals(pzName)&&parkingZoneNov.getId()!=parkingZoneId) {
+                        throw new IllegalStateException("There is already a ParkingZone with the same name");
+                    }
+
+                    parkingZoneNov.setPzName(pzName);
                 }
 
-                parkingZoneNov.setPzName(pzName);
+                if (price != 0 && !Objects.equals(parkingZoneNov.getPrice(), price)) {
+                    parkingZoneNov.setPrice(price);
+                }
+
+                if (location != null && location.length() > 0 && !Objects.equals(parkingZoneNov.getAddress(), location)) {
+                    parkingZoneNov.setAddress(location);
+                }
+
+                if (from != 0 && !Objects.equals(parkingZoneNov.getFrom(), from)) {
+                    parkingZoneNov.setFrom(from);
+                }
+
+                if (to != 0 && !Objects.equals(parkingZoneNov.getTo(), to)) {
+                    parkingZoneNov.setTo(to);
+                }
+
+                if (color != null && color.length() > 0 && !Objects.equals(parkingZoneNov.getColor(), color)) {
+                    parkingZoneNov.setColor(color);
+                }
+
+                if (parkingZoneLocation != null) {
+                    parkingZoneNov.setParkingZoneLocation(parkingZoneLocation);
+                }
+
+                if (!parkingSpaces.isEmpty()) {
+                    ParkingZone parkingZone = parkingZoneRepository.findByPzId(parkingZoneId);
+//                    for(ParkingSpace space :parkingZone.getParkingSpaces()){
+//                        if(!parkingSpaces.contains(space)){
+//                            for(ParkingSession session: parkingSessionRepository.findByParkingZonePzName(pzName)){
+//                                if(session.getParkingSpace().getPsId()==space.getPsId())
+//                                    throw new IllegalStateException("Vlegov vo iffot");
+//                            }
+//                        }
+//                    }
+                    //TODO: treba da se opravi 
+                    parkingZone.setParkingSpaces(null);
+                    List<ParkingSpace> spacesToAdd = new ArrayList<>(parkingSpaces);
+                    parkingZone.setParkingSpaces(spacesToAdd);
+                }
+                if (!odgovorniLica.isEmpty()) {
+                    ParkingZone parkingZone = parkingZoneRepository.findByPzId(parkingZoneId);
+                    for (Integer vrabotenId : odgovorniLica) {
+                        Vraboten vrabotenToAdd = vrabotenRepository.findByVrabotenId(vrabotenId);
+                        if(vrabotenToAdd!=null)
+                        vrabotenToAdd.getParkingZones().add(parkingZone);
+                    }
+                }
+
+
+                return parkingZoneNov;
+            } else {
+                throw new IllegalStateException("There ParkingZone does not exist");
             }
+        }
 
-            if (price != 0 && !Objects.equals(parkingZoneNov.getPrice(), price)) {
-                parkingZoneNov.setPrice(price);
+
+        @Transactional
+        public Optional<ParkingZone> deleteParkingZone ( int parkingZoneId){
+            Optional<ParkingZone> parkingZoneOpt = Optional.ofNullable(parkingZoneRepository.findByPzId(parkingZoneId));
+            if (parkingZoneOpt.isPresent()) {
+                parkingZoneRepository.deleteByPzId(parkingZoneId);
+            } else {
+                throw new IllegalStateException("ParkingZone doesn't exist, therefore can't be deleted");
             }
-
-            if (capacity != 0 && !Objects.equals(parkingZoneNov.getCapacity(), capacity)) {
-                parkingZoneNov.setCapacity(capacity);
-            }
-
-            if (location != null && location.length() > 0 && !Objects.equals(parkingZoneNov.getLocation(), location)) {
-                parkingZoneNov.setLocation(location);
-            }
-
-            if (from != 0 && !Objects.equals(parkingZoneNov.getFrom(), from)) {
-                parkingZoneNov.setFrom(from);
-            }
-
-            if (to != 0 && !Objects.equals(parkingZoneNov.getTo(), to)) {
-                parkingZoneNov.setTo(to);
-            }
-
-            if (color != null && color.length() > 0 && !Objects.equals(parkingZoneNov.getColor(), color)) {
-                parkingZoneNov.setColor(color);
-            }
-
-            if(parkingZoneLocation!=null){
-                parkingZoneNov.setParkingZoneLocation(parkingZoneLocation);
-            }
-
-            if(!parkingSpaces.isEmpty()){
-                //TODO kreiraj lista od parkingSpaces, ni gi prakja false isHandicaped i isTaken
-                parkingZoneNov.setParkingSpaces(parkingSpaces);
-            }
-<<<<<<< HEAD
-            if(!odgovorniLica.isEmpty()){
-
-                parkingZoneNov.setOdgovorniLica(odgovorniLica);
-            }
-=======
->>>>>>> 9504a097ce80831ea7e7130dff7215d5fbf8e939
-
-            return parkingZoneNov;
-        } else {
-            throw new IllegalStateException("There ParkingZone does not exist");
+            return parkingZoneOpt;
         }
     }
 
-    @Transactional
-    public Optional<ParkingZone> deleteParkingZone(int parkingZoneId) {
-        Optional<ParkingZone> parkingZoneOpt = Optional.ofNullable(parkingZoneRepository.findByPzId(parkingZoneId));
-        if (parkingZoneOpt.isPresent()) {
-            parkingZoneRepository.deleteByPzId(parkingZoneId);
-        } else {
-            throw new IllegalStateException("ParkingZone doesn't exist, therefore can't be deleted");
-        }
-        return parkingZoneOpt;
-    }
-}
